"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CoerceOpenApiProject = void 0;
const schematics_1 = require("@angular-devkit/schematics");
const schematics_utilities_1 = require("@rxap/schematics-utilities");
/**
 * @deprecated use function from the @rxap/schematics-utilities package
 */
function CoerceOpenApiProject(project, prefix, directory) {
    return (host) => {
        const angularJson = (0, schematics_utilities_1.GetAngularJson)(host);
        const projectName = `${directory ? directory.split('/').join('-') + '-' : ''}${project}`;
        if (!angularJson.projects.hasOwnProperty(projectName)) {
            const defaultProject = angularJson.projects[angularJson.defaultProject];
            const defaultProjectPrefix = prefix !== null && prefix !== void 0 ? prefix : defaultProject.prefix;
            return (0, schematics_1.chain)([
                (0, schematics_1.externalSchematic)('@nx/angular', 'library', {
                    name: project,
                    importPath: `@${defaultProjectPrefix}/${projectName}`,
                    prefix,
                    directory,
                }),
                (tree) => {
                    var _a, _b, _c, _d;
                    const baseTsconfig = JSON.parse((_b = (_a = tree.read('/tsconfig.base.json')) === null || _a === void 0 ? void 0 : _a.toString()) !== null && _b !== void 0 ? _b : '{}');
                    const paths = (_d = (_c = baseTsconfig === null || baseTsconfig === void 0 ? void 0 : baseTsconfig.compilerOptions) === null || _c === void 0 ? void 0 : _c.paths) !== null && _d !== void 0 ? _d : {};
                    if (Object.keys(paths).length) {
                        for (const key of Object.keys(paths)) {
                            if (directory) {
                                if (key.match(new RegExp(`\/${directory.split('/').join('-')}-${project}$`))) {
                                    delete paths[key];
                                    paths[key + '/*'] = [
                                        `libs/${directory}/${project}/src/lib/*`,
                                    ];
                                }
                            }
                            else {
                                if (key.match(new RegExp(`\/${project}$`))) {
                                    delete paths[key];
                                    paths[key + '/*'] = [`libs/${project}/src/lib/*`];
                                }
                            }
                        }
                        tree.overwrite('/tsconfig.base.json', JSON.stringify(baseTsconfig, undefined, 2));
                    }
                },
            ]);
        }
        return (0, schematics_1.noop)();
    };
}
exports.CoerceOpenApiProject = CoerceOpenApiProject;
//# sourceMappingURL=coerce-open-api-project.js.map